'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactabular = require('reactabular');

var _reactabularDnd = require('reactabular-dnd');

var dnd = _interopRequireWildcard(_reactabularDnd);

var _reactabularTree = require('reactabular-tree');

var tree = _interopRequireWildcard(_reactabularTree);

var _reactabularUtils = require('reactabular-utils');

var _reactabularSelect = require('reactabular-select');

var _reactabularVirtualized = require('reactabular-virtualized');

var Virtualized = _interopRequireWildcard(_reactabularVirtualized);

var _redux = require('redux');

var _selectabular = require('selectabular');

var _selectabular2 = _interopRequireDefault(_selectabular);

var _findIndex2 = require('lodash/findIndex');

var _findIndex3 = _interopRequireDefault(_findIndex2);

var _types = require('./types');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EasyTable = function (_React$Component) {
  _inherits(EasyTable, _React$Component);

  function EasyTable(props) {
    _classCallCheck(this, EasyTable);

    var _this = _possibleConstructorReturn(this, (EasyTable.__proto__ || Object.getPrototypeOf(EasyTable)).call(this, props));

    _this.state = {
      selectedRow: {}
    };

    _this.bindColumns = _this.bindColumns.bind(_this);
    _this.selectRow = _this.selectRow.bind(_this);
    _this.onRow = _this.onRow.bind(_this);

    // References to header/body elements so they can be
    // kept in sync while scrolling.
    _this.tableHeader = null;
    _this.tableBody = null;
    return _this;
  }

  _createClass(EasyTable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // We have refs now. Force update to get those to Header/Body.
      this.forceUpdate();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var rowKey = _props.rowKey;
      var query = _props.query;
      var headerExtra = _props.headerExtra;
      var sortingColumns = _props.sortingColumns;
      var tableWidth = _props.tableWidth;
      var tableHeight = _props.tableHeight;
      var components = _props.components;
      var idField = _props.idField;
      var parentField = _props.parentField;
      var classNames = _props.classNames;
      var onRow = _props.onRow;

      var tableComponents = _extends({}, components, {
        body: {
          wrapper: Virtualized.BodyWrapper,
          row: Virtualized.BodyRow
        }
      });
      var selectedRow = this.state.selectedRow;

      var columns = this.bindColumns(this.props);

      if (hasDraggableHeaders(columns)) {
        tableComponents.header = {
          cell: dnd.Header
        };
      }

      // Escape early if there are no columns to display
      if (!columns.length) {
        return null;
      }

      var rows = (0, _redux.compose)(tree.filter({ fieldName: 'showingChildren', parentField: parentField }), tree.sort({
        columns: columns,
        idField: idField,
        sortingColumns: sortingColumns,
        strategy: _reactabular.sort.strategies.byProperty
      }), _reactabular.highlight.highlighter({ columns: columns, matches: _reactabular.search.matches, query: query }), tree.search({ columns: columns, query: query, idField: idField, parentField: parentField }), _reactabular.resolve.resolve({
        columns: columns,
        method: function method(_ref) {
          var rowData = _ref.rowData;
          var rowIndex = _ref.rowIndex;
          var column = _ref.column;
          return _reactabular.resolve.byFunction('cell.resolve')({
            rowData: _reactabular.resolve.nested({
              rowData: _reactabular.resolve.index({ rowData: rowData, rowIndex: rowIndex }),
              column: column
            }),
            column: column
          });
        }
      }))(this.props.rows);
      var selectedRowIndex = getSelectedRowIndex({
        rows: this.props.rows,
        rowKey: this.props.rowKey,
        selectedRow: selectedRow
      });

      return (0, _reactabularSelect.byArrowKeys)({
        rows: rows,
        selectedRowIndex: selectedRowIndex,
        onSelectRow: this.selectRow
      })(_react2.default.createElement(
        _reactabular.Table.Provider,
        {
          className: classNames.table && classNames.table.wrapper,
          components: tableComponents,
          columns: columns,
          style: { width: tableWidth }
        },
        _react2.default.createElement(
          _reactabular.Sticky.Header,
          {
            className: classNames.header && classNames.header.wrapper,
            style: {
              maxWidth: tableWidth
            },
            ref: function ref(tableHeader) {
              _this2.tableHeader = tableHeader && tableHeader.getRef();
            },
            tableBody: this.tableBody
          },
          headerExtra
        ),
        _react2.default.createElement(Virtualized.Body, {
          className: classNames.body && classNames.body.wrapper,
          rows: rows,
          rowKey: rowKey,
          onRow: this.onRow,
          style: {
            maxWidth: tableWidth
          },
          height: tableHeight,
          ref: function ref(tableBody) {
            _this2.tableBody = tableBody && tableBody.getRef();
          },
          tableHeader: this.tableHeader
        })
      ));
    }
  }, {
    key: 'bindColumns',
    value: function bindColumns(_ref2) {
      var _this3 = this;

      var columns = _ref2.columns;
      var props = _ref2.props;

      var resizable = (0, _reactabular.resizableColumn)({
        onDrag: this.props.onDragColumn,
        props: props.resize,
        parent: this.props.window
      });

      var getSortingColumns = function getSortingColumns() {
        return _this3.props.sortingColumns || {};
      };
      var sortable = _reactabular.sort.sort({
        getSortingColumns: getSortingColumns,
        onSort: function onSort(selectedColumn) {
          var sortingColumns = _reactabular.sort.byColumns({
            sortingColumns: _this3.props.sortingColumns,
            selectedColumn: selectedColumn
          });

          _this3.props.onSort(sortingColumns);
        },
        strategy: _reactabular.sort.strategies.byProperty,
        props: props.sort
      });
      var resetable = _reactabular.sort.reset({
        event: 'onDoubleClick',
        getSortingColumns: getSortingColumns,
        strategy: _reactabular.sort.strategies.byProperty,
        onReset: function onReset(_ref3) {
          var sortingColumns = _ref3.sortingColumns;
          return _this3.props.onSort(sortingColumns);
        }
      });

      return columns.map(function (column) {
        return _this3.bindColumn({
          column: column,
          sortable: sortable,
          getSortingColumns: getSortingColumns,
          resetable: resetable,
          resizable: resizable
        });
      });
    }
  }, {
    key: 'bindColumn',
    value: function bindColumn(_ref4) {
      var _this4 = this;

      var column = _ref4.column;
      var sortable = _ref4.sortable;
      var getSortingColumns = _ref4.getSortingColumns;
      var resetable = _ref4.resetable;
      var resizable = _ref4.resizable;

      if (column.header || column.cell) {
        var _ret = function () {
          var props = column.props || {};
          var header = column.header || {};
          var cell = column.cell || {};
          var existingHeaderProps = header.props;
          var existingHeaderFormat = header.format || function (v) {
            return v;
          };
          var existingHeaderTransforms = header.transforms || [];
          var existingCellFormat = cell.format || function (v) {
            return v;
          };
          var newCellFormats = [existingCellFormat];
          var newHeaderFormats = [existingHeaderFormat];
          var newHeaderProps = existingHeaderProps;
          var newHeaderTransforms = existingHeaderTransforms;
          var newStyle = {};

          if (header.sortable) {
            newHeaderFormats.push(_reactabular.sort.header({
              sortable: sortable,
              getSortingColumns: getSortingColumns,
              strategy: _reactabular.sort.strategies.byProperty
            }));
            newHeaderTransforms = newHeaderTransforms.concat([resetable]);
          }

          if (header.resizable) {
            newHeaderFormats.push(resizable);
          }

          if (header.draggable) {
            newHeaderProps = {
              // DnD needs this to tell header cells apart
              label: header.label,
              onMove: function onMove(labels) {
                var _dnd$moveLabels = dnd.moveLabels(_this4.props.columns, labels);

                var source = _dnd$moveLabels.source;
                var target = _dnd$moveLabels.target;
                var columns = _dnd$moveLabels.columns;


                var tmpWidth = source.width;
                source.width = target.width;
                target.width = tmpWidth;

                _this4.props.onMoveColumns({
                  source: source,
                  target: target,
                  columns: columns
                });
              }
            };
          }

          if (cell.highlight) {
            newCellFormats.push(function (v, extra) {
              return _reactabular.highlight.cell(existingCellFormat(v, extra), extra);
            });
          }

          if (cell.toggleChildren) {
            newCellFormats.push(tree.toggleChildren({
              getRows: function getRows() {
                return _this4.props.rows;
              },
              getShowingChildren: function getShowingChildren(_ref5) {
                var rowData = _ref5.rowData;
                return rowData.showingChildren;
              },
              toggleShowingChildren: _this4.props.onToggleShowingChildren,
              // Without this it will perform checks against default id
              idField: _this4.props.idField,
              parentField: _this4.props.parentField,
              props: _this4.props.toggleChildrenProps
            }));
          }

          var newCellFormat = function newCellFormat(value, extra) {
            return newCellFormats.reduce(function (parameters, format) {
              return {
                value: format(parameters.value, parameters.extra),
                extra: extra
              };
            }, { value: value, extra: extra }).value;
          };

          var newHeaderFormat = function newHeaderFormat(value, extra) {
            return newHeaderFormats.reduce(function (parameters, format) {
              return {
                value: format(parameters.value, parameters.extra),
                extra: extra
              };
            }, { value: value, extra: extra }).value;
          };

          if (column.width) {
            newStyle = {
              width: column.width,
              minWidth: column.width
            };
          }

          return {
            v: _extends({}, column, {
              props: _extends({}, props, {
                style: _extends({}, props.style, newStyle)
              }),
              header: _extends({}, header, {
                props: newHeaderProps,
                transforms: newHeaderTransforms,
                format: newHeaderFormat
              }),
              cell: _extends({}, cell, {
                format: newCellFormat
              })
            })
          };
        }();

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
      }

      return column;
    }
  }, {
    key: 'onRow',
    value: function onRow(row, _ref6) {
      var _this5 = this;

      var rowIndex = _ref6.rowIndex;
      var rowKey = _ref6.rowKey;

      var _props$onRow = this.props.onRow(row, { rowIndex: rowIndex, rowKey: rowKey });

      var className = _props$onRow.className;

      var props = _objectWithoutProperties(_props$onRow, ['className']);

      return _extends({
        className: (0, _reactabularUtils.mergeClassNames)(className, row.selected && 'selected-row'),
        onClick: function onClick() {
          return _this5.selectRow(rowIndex);
        }
      }, props);
    }
  }, {
    key: 'selectRow',
    value: function selectRow(selectedRowIndex) {
      var _props2 = this.props;
      var rowKey = _props2.rowKey;
      var rows = _props2.rows;

      var selectedRowId = rows[selectedRowIndex][rowKey];
      var result = (0, _redux.compose)(_selectabular2.default.rows(function (row) {
        return row[rowKey] === selectedRowId;
      }), _selectabular2.default.none)(rows);
      var selectedRow = result.selectedRows[0];

      this.props.onSelectRow({
        selectedRowId: selectedRow && selectedRow[rowKey],
        selectedRow: selectedRow
      });

      this.setState({
        rows: result.rows,
        selectedRow: selectedRow
      });
    }
  }]);

  return EasyTable;
}(_react2.default.Component);

process.env.NODE_ENV !== "production" ? EasyTable.propTypes = _types.propTypes : void 0;
EasyTable.defaultProps = _types.defaultProps;

function hasDraggableHeaders(columns) {
  return columns.some(function (column) {
    return column.header && column.header.draggable;
  });
}

function getSelectedRowIndex(_ref7) {
  var rows = _ref7.rows;
  var selectedRow = _ref7.selectedRow;
  var rowKey = _ref7.rowKey;

  return (0, _findIndex3.default)(rows, _defineProperty({}, rowKey, selectedRow[rowKey]));
}

exports.default = EasyTable;