'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultProps = exports.propTypes = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var globalWindow = window;

var propTypes = {
  window: _react2.default.PropTypes.object, // DOM window
  columns: _react2.default.PropTypes.array,
  rows: _react2.default.PropTypes.array,
  rowKey: _react2.default.PropTypes.string.isRequired,
  query: _react2.default.PropTypes.object,
  sortingColumns: _react2.default.PropTypes.object,
  headerExtra: _react2.default.PropTypes.any,
  tableWidth: _react2.default.PropTypes.any.isRequired,
  tableHeight: _react2.default.PropTypes.any.isRequired,
  classNames: _react2.default.PropTypes.object,
  props: _react2.default.PropTypes.object,
  styles: _react2.default.PropTypes.object,
  components: _react2.default.PropTypes.object,
  toggleChildrenProps: _react2.default.PropTypes.object,
  // Custom tree fields
  idField: _react2.default.PropTypes.string,
  parentField: _react2.default.PropTypes.string,
  // Handlers
  onRow: _react2.default.PropTypes.func,
  onWidth: _react2.default.PropTypes.func,
  onDragColumn: _react2.default.PropTypes.func,
  onMoveColumns: _react2.default.PropTypes.func,
  onSelectRow: _react2.default.PropTypes.func,
  onSort: _react2.default.PropTypes.func,
  onToggleShowingChildren: _react2.default.PropTypes.func
};

var defaultProps = {
  window: globalWindow,
  classNames: {
    table: null,
    header: {
      wrapper: null
      // TODO
      /*
      row: null,
      cell: null
      */
    },
    body: {
      wrapper: null
      // TODO
      /*
      row: null,
      cell: null
      */
    }
  },
  props: {
    resize: {
      container: {},
      value: {},
      handle: {}
    },
    sort: {
      container: {},
      value: {},
      order: {}
    }
  },
  components: {},
  toggleChildrenProps: {},
  // Custom tree fields
  idField: 'id',
  parentField: 'parent',
  // Handlers
  onRow: function onRow() {
    return {};
  },
  onDragColumn: function onDragColumn() {},
  onMoveColumns: function onMoveColumns() {},
  onSelectRow: function onSelectRow() {},
  onSort: function onSort() {},
  onToggleShowingChildren: function onToggleShowingChildren() {}
};

exports.propTypes = propTypes;
exports.defaultProps = defaultProps;